/***************************************************************************
                          bibentrytable.h  -  description
                             -------------------
    begin                : Sun May 25 2003
    copyright            : (C) 2003 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _BIBENTRYTABLE_H
#define _BIBENTRYTABLE_H


#include <vector>
#include <list>
#include <string>
using namespace std;

#include "bibentry.h"
#include "bibfile.h"

class BibentryTable
{
public:
    BibentryTable();
    ~BibentryTable();

    void clear();
    void clearStringMacro();
    void new_entry(BibEntry&);
    void new_entry(BibEntry*);
    void new_stringMacro(BibEntry*);
    BibEntry *get_stringMacro(int);
    BibEntry *get_entry(int);
    int readBibfile(char *, bool import = 0);
	QString getPreamble() {return preamble; }
	void setPreamble(QString st) { preamble = st; }
    string dbname;
    int size()
    {
        return entryTab.size();
    }
    int stringMacroSize(){ return stringMacroTab.size(); }

    int writeBibfile(const char *name, int fieldDelimiter = 0);

    void removeEntryTab();
    void removeStringMacroTab();

    void createKeys(const char *connectingString = "");

    int searchKey(const char *s, int start=0);

    void createKey(int i, const char *connectingString = "");

    int search_string(char *s, int first, int att, int opt);

    void delete_entry(int i);

    void sort(int ascending, const char *s = "citation key");

    int removeDuplicated(int compareSetting=0);

    void updateEntryIndices(void);

    void change_entry(int index, BibEntry *);

private:
    static vector<BibEntry *> entryTab;
    static vector<BibEntry *> stringMacroTab;
	QString preamble;
};

void print_entry(FILE *fp, BibEntry *e, int fieldDelimiter = 0);

#endif
