/***************************************************************************
                          entrydef.cpp  -  description
                             -------------------
    begin                : Sat May 24 2003
    copyright            : (C) 2003 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <list>
#include <vector>

#include <algorithm>
#include <stdio.h>
#include "entrydef.h"

#include <ctype.h>

#include <string>
using namespace std;

#include <map>

map<string, BibEntryDef *, less<string> > entrydefs;

// Just to store the entrydef names, for some reason unaccesible from map
vector<string> entrydefTab;

//
vector<string> fieldNameTab;

//
vector<string> extraFieldNameTab;

/*
static void Stolower(char *s)
{
    for (int i=0; s[i] > ' '; i++)
        s[i] = tolower(s[i]);
}


static void Stoupper(char *s)
{
    for (int i=0; s[i] > ' '; i++)
        s[i] = toupper(s[i]);
}
*/
static int get_fieldname_idx(char * n)
{
    for (unsigned int i=0; i<fieldNameTab.size(); i++)
    {
        if (strcmp(n, fieldNameTab[i].c_str())==0)
        {
            return i;
        }
    }

    return -1;
}

static int insert_fieldname(char * n)
{
    for (unsigned int i=0; i<fieldNameTab.size(); i++)
    {
        if (strcmp(n, fieldNameTab[i].c_str())==0)
        {
            return i;
        }
    }

    fieldNameTab.push_back(n);

    return fieldNameTab.size() - 1;
}


void delete_entrydef(const char *name)
{

    vector<string>::iterator it;
    it = entrydefTab.begin();

    unsigned int i = 0;
    while( strcmp(name, entrydefTab[i].c_str())!=0  && i < entrydefTab.size()-1)
    {
        i++;
        it++;

    }

    //it = entrydefTab.end();
    entrydefTab.erase(it);

    BibEntryDef* entryDef = getBibEntryDef(name);
    entrydefs.erase(name);
    delete entryDef;

}


void new_entrydef(const char* xname, const char* required, const char* optional, bool overwrite, bool specialx, bool hidden)
{
    int i, rl, ol;
    BibEntryDef *def;
    if (overwrite)
    {
        def = getBibEntryDef( xname);
        if (def)
        {
            delete 	def->name;
            delete def->required;
            delete def->optional;

        }
        else
            def = new BibEntryDef;

    }
    else
        def = new BibEntryDef;
    char *aux;
    char s[250];
    int iaux[100];

    //char* name = new char(strlen(xname)+1);
    def->name = new char[strlen(xname)+1];
    int j = strlen(xname);
    //name[j] = 0;
    def->name[j] = 0;

    //    char* name = xname;
	
	for(i=0;i<(int) (strlen(xname));i++)
    {
        def->name[i] = tolower(xname[i]);
    }



    //cerr << "Def name length : "<< strlen(def->name) << "\n";
    //def->name = name;
    //cerr << "newdef: " << def->name << "\n";
    rl = strlen(required);
    ol = strlen(optional);


    // Number of required entries
    def->nreq = 0;
    strcpy(s, required);

	for(i=0;i<(int) (strlen(s) );i++)
    {
        s[i] = tolower(s[i]);
    }


    //cerr << "required " << required << "\n";
    if (rl > 0)
    {
        aux = &s[0];
        for (i=0; i < rl; i++)
        {
            if (required[i] == ' ' || required[i] == '\0')
            {
                s[i] = '\0';
                iaux[def->nreq++] = insert_fieldname(aux);
                aux = &s[i+1];
            }
        }
        iaux[def->nreq++] = insert_fieldname(aux);
        def->required = new int[def->nreq];
        for (i=0; i < def->nreq; i++)
            def->required[i] = iaux[i];
    }

    // Number of optional entries
    def->nopt = 0;
    strcpy(s, optional);
	for(i=0;i<(int)(strlen(s));i++)
    {
        s[i] = tolower(s[i]);
    }
    //cerr << "optional " << optional << "\n";
    if (ol > 0)
    {
        aux = &s[0];
        for (i=0; i < ol; i++)
        {
            if (optional[i] == ' ' || optional[i] == '\0')
            {
                s[i] = '\0';
                iaux[def->nopt++] = insert_fieldname(aux);
                aux = &s[i+1];
            }
        }
        iaux[def->nopt++] = insert_fieldname(aux);
        def->optional = new int[def->nopt];
        for (i=0; i < def->nopt; i++)
            def->optional[i] = iaux[i];
    }


    def->isHidden = hidden;
    def->isSpecial = specialx;

    entrydefs[def->name] = def;
    //    entrydefs.push_back(def);

    if (!overwrite)
    {
        //		cerr << "newdef: [" << def->name << "]\n";
        entrydefTab.push_back(def->name);
    }

}


void new_undefined_entrydef(const char* xname)
{
    BibEntryDef *def = new BibEntryDef;
    def->name = new char[strlen(xname)+1];
    int j = strlen(xname);
    //name[j] = 0;
    def->name[j] = 0;

    //    char* name = xname;

	for(int i=0;i<(int)(strlen(xname));i++)
    {
        def->name[i] = tolower(xname[i]);
    }
    def->nreq = 0;
    def->nopt =  fieldNameTab.size();
    def->optional = new int[def->nopt];
    def->required = NULL;
    for (int i = 0; i< def->nopt; i++)
    {
        def->optional[i] = i;
    }
    def->isHidden = true;
    def->isSpecial = false;
    entrydefs[def->name] = def;
    entrydefTab.push_back(def->name);

}


BibEntryDef *getBibEntryDef(const char *n)
{
    int i;
    char s[255];

    // Non-case sensitive
    //for (i=0; n[i] > ' '; i++)
	for (i=0; i < (int)(strlen(n)); i++)
        s[i] = tolower(n[i]);
    s[i] = '\0';

    if (entrydefs.find(s) != entrydefs.end())
    {
        return entrydefs[s];
    }

    //    cerr << "didn't find1 [" << s << "]" << endl;
    //    cerr << "didn't find2 [" << n << "]" << endl;
    return 0;
}

char *BibEntryDef::getRequired(int i)
{
    if (i > nreq || i < 0)
        return 0;

    return( const_cast<char*>(fieldNameTab[required[i]].c_str()) );
}


char *BibEntryDef::getOptional(int i)
{
    if (i > nopt || i < 0)
        return 0;

    return( const_cast<char*>(fieldNameTab[optional[i]].c_str()) );
}


int BibEntryDef::getFieldIdx(char *fx)
{
    int k = get_fieldname_idx(fx);

    if (k >= 0)
    {
        for (int i=0; i < nreq; i++)
            if (k == required[i])
                return i;

        for (int i=0; i < nopt; i++)
            if (k == optional[i])
                return i+nreq;
    }

    return -1;
}




char *get_entrytype_name(int i)
{
    unsigned int ui;
    ui=(unsigned int)i;
    if (0 <= i && ui < entrydefTab.size())
    {
        return ( const_cast<char*>(entrydefTab[ui].c_str()));
    }

    return 0;
}



int set_globalfield_name(char *n)
{
    string name = n;

    // return the corresponding index if the name already exists
    for (unsigned int i=0; i<fieldNameTab.size(); i++)
    {
        if (name == fieldNameTab[i])
        {
            return i;
        }
    }

    for (unsigned int i=0; i<extraFieldNameTab.size(); i++)
    {
        if (name == extraFieldNameTab[i])
        {
            return i + fieldNameTab.size();
        }
    }

    // it doesn't exist
    extraFieldNameTab.push_back(name);

    return fieldNameTab.size() + extraFieldNameTab.size() - 1;
}


char *get_globalfield_name(int idx)
{
    unsigned int ui;
    ui=(unsigned int)idx;
    if (ui < fieldNameTab.size())
        return (const_cast<char*>(fieldNameTab[ui].c_str()));

    ui -= fieldNameTab.size();

    if (ui < extraFieldNameTab.size())
        return (const_cast<char*>(extraFieldNameTab[ui].c_str()));

    return 0;
}

