/***************************************************************************
                          entrydef.h.h  -  description
                             -------------------
    begin                : Sat May 24 2003
    copyright            : (C) 2003 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #ifndef _ENTRYDEF_H
 #define _ENTRYDEF_H
 
 #include <iostream>
 #include <vector>
 #include <algorithm>
 #include <stdio.h>


 #include <list>

  #include <string>
  using namespace std;
 
 class BibEntryDef
{
 public:
    int nreq, nopt;
    //string name;
    char *name;
    int *required;
    int *optional;

    char *getRequired(int);
    char *getOptional(int);
    int getFieldIdx(char *);
	
	bool isSpecial;
	bool isHidden;

    ~BibEntryDef() {
	delete[] required;
	delete[] optional;
	delete[] name;
    }
};

void delete_entrydef(const char *name);

void new_entrydef(const char* name, const char* required, const char* optional, bool overwrite=false, bool special=false, bool hidden=false);

void new_undefined_entrydef(const char* name);

BibEntryDef *getBibEntryDef(const char *);

char *get_entrytype_name(int);

int set_globalfield_name(char *);
char *get_globalfield_name(int);

/*
char *get_bibtex_style(int);
*/

#endif
