//
// C++ Interface: fieldcompletion
//
// Description:
//
//
// Author: Thach Nguyen <thach.nguyen@rmit.edu.au>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef FIELDCOMPLETION_H
#define FIELDCOMPLETION_H

#include <kcompletion.h>
#include <qregexp.h>

/**
	@author Thach Nguyen <thach.nguyen@rmit.edu.au>
	Based on tellico
*/
class FieldCompletion : public KCompletion
{
    Q_OBJECT

public:
	FieldCompletion(bool multiple);

    void setMultiple(bool m) { m_multiple = m; }
    virtual QString makeCompletion(const QString& string);
    virtual void clear();
	void setDelimiter(QRegExp delimiter) { rx = delimiter; };

protected:
    virtual void postProcessMatch(QString* match) const;
    virtual void postProcessMatches(QStringList* matches) const;
    virtual void postProcessMatches(KCompletionMatches* matches) const;

private:
    bool m_multiple;
    QString m_beginText;
	QRegExp rx;
};
#endif
