//
// C++ Interface: kbibeditauthors
//
// Description: 
//
//
// Author: Thach Nguyen <thach.nguyen@rmit.edu.au>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KBIBEDITAUTHORS_H
#define KBIBEDITAUTHORS_H

class KLineEdit;
class KPushButton;
class QListView;
class QListViewItem;

#include <kdialogbase.h>
#include <qobject.h>
#include <qstring.h>
#include <kcombobox.h>

/**
	@author Thach Nguyen <thach.nguyen@rmit.edu.au>
*/
class KBibEditAuthors : public KDialogBase
{
Q_OBJECT
public:
	KBibEditAuthors(QWidget *parent = 0, const char *name = 0, bool modal = false);

    ~KBibEditAuthors();
	void setAuthors(QString st);
	QString getAuthors();
	
private slots:
	void slotAdd();
	void slotEdit();
	void slotDelete();
	void slotUp();
	void slotDown();
	void slotItemRenamed( QListViewItem * item, int col, const QString & text );
	void updateGUI();
	void slotExistingAuthor();
private:
	KComboBox *existingAuthorSelect;
	QListView *m_listView;
	KPushButton *addBtn;
	KPushButton *editBtn;
	KPushButton *deleteBtn;
	KPushButton *upBtn;
	KPushButton *downBtn;	
	
};

#endif
