/***************************************************************************
                          kbibeditentrydlg.h  -  description
                             -------------------
    begin                : Sat May 31 2003
    copyright            : (C) 2003 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBIBEDITENTRYDLG_H
#define KBIBEDITENTRYDLG_H

#include <qwidget.h>
#include <qtextedit.h>
#include <kdialogbase.h>
#include <qptrlist.h>
#include <qstringlist.h>
#include <qlabel.h>
#include <klineedit.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qstring.h>
#include <qpushbutton.h>
#include <qscrollview.h>
#include <qtabwidget.h>
#include <qlayout.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qvaluelist.h>
#include <qlistview.h>

#include <kpushbutton.h>

#include "bibentrytable.h"
#include "bibentry.h"
#include "entrydef.h"

/**
  *@author Thach Nguyen
  */

class KBibEditEntryDlg : public KDialogBase
{
    Q_OBJECT
public:
    KBibEditEntryDlg(BibEntry *entry = 0, QWidget *parent=0, const char *name=0);
    ~KBibEditEntryDlg();
    /** No descriptions */
    void updateDlg(char * entryTypeName);
    /** No descriptions */
    void updateContent(BibEntry *entry);
    /** No descriptions */
    BibEntry * getBibEntry(void);
    BibEntry * getEditedBibEntry(void );
    void accept(void);


private:
    void createJournalList();
    void createStringMacroList();
    int fieldIdx;

    QPtrList<QLabel> rqLabels;
    QPtrList<QLabel> optLabels;
    QPtrList<KLineEdit> rqFields;
    QPtrList<KLineEdit> optFields;
    QPtrList<QRadioButton> asStringMacros;
    QPtrList<QPushButton> stringMacroSelect;
    QPtrList<QPushButton> editAuthor;
    QButtonGroup* macroSelectGrp;
    QButtonGroup* editAuthorGrp;
    QValueList<int> editAuthorIndex;
    QStringList  journalList;

    QComboBox * entryTypeSelect;
    KLineEdit * keyField;

    QComboBox * journalName;
    QPushButton *journalSelect;
    QTabWidget *reqTab;
    QTabWidget *optTab;
    QComboBox * stringMacroList;

    QScrollView *rqScrollView;
    QGroupBox * rqBox;
    QScrollView *optScrollView;
    QGroupBox * optBox;
    QLabel* keyLabel;
    QLabel* entryTypeLabel;

    BibEntry *m_entry;
    /**  */
    QPushButton * urlBrowse;
    /**  */
    int urlIndex;
    int journalIndex;
    /**  */
    QPushButton * createKeyBttn;
    QPushButton * lockKeyBttn;
    QPushButton * editTypeBttn;
    QTextEdit *sourceEdit;
	QTextEdit *noteEdit;
    QTextEdit *abstractEdit;
    QWidget *abstractPage;
    QTabWidget *mainTab;
    int prevTabIndex;

    QVBoxLayout *rqLayout;
    QVBoxLayout *optLayout;
	
	
	QListView *extraFieldView;
	KPushButton *extraFieldAddBtn;
	KPushButton *extraFieldEditBtn;
	KPushButton *extraFieldDeleteBtn;
	
private slots:
	void slotExtraFieldAdd();
	void slotExtraFieldEdit();
	void slotExtraFieldDelete();
	void slotExtraFielItemRenamed( QListViewItem * item, int col, const QString & text );
	void updateExtraFieldGUI();	
	
	
public slots: // Public slots
    /** No descriptions */
    void slotEntryTypeChange(int);
    void slotEditType();
    /** No descriptions */
    void slotURLBrowse();
    /** No descriptions */
    void slotCreateKey();

    void slotJournalSelect();
    void slotStringMacroSelect(int);
    void slotSelectJournalName(int);
    void slotSelectStringMacro(int);
    void slotLockKey();
    void slotTabChanged();
    void slotEditAuthor(int);
};

#endif
