/***************************************************************************
                          kbibentrytypeparser  -  description
                             -------------------
    begin                : Sat Mar 20 2004
    copyright            : (C) 2004 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kbibentrytypeparser.h"


#include <stdio.h>
#include <qstring.h>
#include <iostream>

#include "bibentry.h"
#include "entrydef.h"
using namespace::std;

bool KbibEntryTypeParser::startDocument()
{
    entryType = QString("");
    reqField = QString("");
    optField = QString("");
    level=0;
    start = TRUE;
    req = FALSE;
    return TRUE;
}



bool KbibEntryTypeParser::startElement( const QString&, const QString&,
                                        const QString& qName,
                                        const QXmlAttributes& )
{
    //printf( "%s%s\n", (const char*)indent, (const char*)qName );
    //indent += "    ";
    level++;
    if (level==2)
    {
        entryType = qName;
        reqField = QString("");
        optField = QString("");
        start = TRUE;
        req = FALSE;
    }

    if (level == 3)
    {
        start = TRUE;
        req = !req;
    }

    if (level == 4)
    {
        if (req)
        {
            if (!start)
                reqField +=" ";
            reqField = reqField + qName;
            start = FALSE;

        }
        else
        {
            if (!start)
                optField +=" ";
            optField = optField + qName;
            start = FALSE;

        }


    }

    //cout << "\n" << entryType.ascii() << " " << reqField.ascii() << " " << optField.ascii() << "\n";


    return TRUE;
}

bool KbibEntryTypeParser::endElement( const QString&, const QString&, const QString& )
{
    //        indent.remove( (uint)0, 4 );
    level--;
    if (level == 1)
    {
        //	cout << "\n" << entryType.ascii() << " " << reqField.ascii() << " " << optField.ascii() << "\n";
        new_entrydef(entryType.ascii(), reqField.ascii(), optField.ascii());
    }
    return TRUE;
}

