/***************************************************************************
                          kbiblistviewitem.cpp  -  description
                             -------------------
    begin                : Wed May 28 2003
    copyright            : (C) 2003 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kbiblistviewitem.h"
#include "kbiblistview.h"
#include "kbib.h"
#include <kiconloader.h>
#include <qdragobject.h>

KBibListViewItem::KBibListViewItem(QListView *parent, BibEntry * item, QStringList displayFields, int numAuthorsDisplayed) : KListViewItem(parent)
{
        bibItem = item;

		updateItemContent(displayFields, numAuthorsDisplayed);
}
KBibListViewItem::~KBibListViewItem()
{
}


void  KBibListViewItem::updateItemContent(QStringList displayFields, int numAuthorsDisplayed)
{
	char *fieldName;
	QString field;
	int i = 0;
	QStringList::iterator it;
	
	for (it =  displayFields.begin(); it != displayFields.end(); it++) {

		fieldName = const_cast<char*>((*it).ascii());
		if (strcmp(fieldName, "citation key") == 0){
			field = QString(bibItem->getKey());
			QPixmap pix;
			if (strcmp(bibItem->getField("lockkey"),"Y")==0){
				pix = KGlobal::iconLoader()->loadIcon(QString::fromLatin1("lock"), KIcon::Small);	
			}
			else
				pix = KGlobal::iconLoader()->loadIcon(QString::fromLatin1("unlock"), KIcon::Small);
			setPixmap(i, pix);
		}
		else{
			field = QString(bibItem->getField(fieldName)).simplifyWhiteSpace();
			setPixmap(i, 0);
		}
		if (strcmp(fieldName, "author") == 0 || strcmp(fieldName, "editor") == 0)
			field = reformatAuthors(field, numAuthorsDisplayed);
		setText(i, field);
		i++;
	
	}
	
}


BibEntry* KBibListViewItem::getBibEntry()
{
        return bibItem;
}

/** No descriptions */
void KBibListViewItem::setBibEntry(BibEntry * item)
{
        bibItem = item;
}
