/***************************************************************************
                          kbibnewentrytypedlg  -  description
                             -------------------
    begin                : Sat Mar 6 2004
    copyright            : (C) 2004 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kbibnewentrydefdlg.h"
#include <klocale.h>

#include <qlayout.h>
#include <qhbox.h>
#include <qvbox.h>

#include "bibentrytable.h"
#include "bibentry.h"
#include "entrydef.h"



KbibNewEntryDefDlg::KbibNewEntryDefDlg(QWidget *parent, const char *name)
        :KDialogBase(parent, name, false, i18n("Reference Type"), KDialogBase::Ok|KDialogBase::Cancel, KDialogBase::Ok,false, i18n("Reference Type"))
{

    QWidget* page = new QWidget(this);
    setMainWidget(page);
    QVBoxLayout* l = new QVBoxLayout(page, 0, KDialog::spacingHint());

    QHBox* box1 = new QHBox(page);
    box1->setMargin(4);
    box1->setSpacing(4);

    refTypeLab = new QLabel("Reference Type", box1 );
    refTypeLab->setMinimumWidth(100);

    refTypeEdit = new QLineEdit(box1);
    l->addWidget(box1);
    box1->setStretchFactor(refTypeLab, 0);
    box1->setStretchFactor(refTypeEdit, 1);

    optFieldText = QString("");
    reqFieldText = QString("");

    reqFields = new KEditListBox("Required Fields", page, "Required Fields", true);
    l->addWidget(reqFields);

    optFields = new KEditListBox("Optional Fields", page, "Optional Fields", true);
    optFields->setGeometry(QRect(20,300,300,200) );

    l->addWidget(optFields);
    l->insertSpacing(2,8);
    l->insertSpacing(3,8);
    l->addSpacing(8);
    l->addStretch(10);

    numReq = 0;
    numOpt = 0;
}


KbibNewEntryDefDlg::~KbibNewEntryDefDlg()
{}


/*!
    \fn KbibNewEntryDefDlg::getEntryType()
 */
char * KbibNewEntryDefDlg::getEntryType()
{
    refTypeText = (refTypeEdit->text());
    refTypeText=refTypeText.stripWhiteSpace();
    if (refTypeText.isEmpty())
        return 0;
    return const_cast<char*>(refTypeText.ascii());
}


/*!
    \fn KbibNewEntryDefDlg::getReqFields()
 */




char *  KbibNewEntryDefDlg::getReqFields()
{
    reqFieldText = QString("");
    int n = reqFields->count();
    QString tmp;
    for (int i = 0; i < n ; i++)
    {
        tmp = reqFields->text(i);
        tmp = tmp.stripWhiteSpace();
        if (!(tmp.isEmpty()))
        {
            if (!(reqFieldText.isEmpty()))
                reqFieldText+=QString(" ");
            reqFieldText = reqFieldText+tmp;
            numReq++;
        }

    }
    reqFieldText = reqFieldText.stripWhiteSpace();
    return const_cast<char*>(reqFieldText.ascii());


}





/*!
    \fn KbibNewEntryDefDlg::getOptFields
 */


char *  KbibNewEntryDefDlg::getOptFields()
{
    optFieldText = QString("");
    int n = optFields->count();
    QString tmp;
    for (int i = 0; i < n ; i++)
    {
        tmp = optFields->text(i);
        tmp = tmp.stripWhiteSpace();
        if (!(tmp.isEmpty()))
        {
            if (!(optFieldText.isEmpty()))
                optFieldText+=QString(" ");
            optFieldText = optFieldText+tmp;
            numOpt++;
        }


    }
    if (optFieldText.find(" lockkey", 0, false) < 0 || optFieldText.find("lockkey ", 0, false) < 0)
        optFieldText=optFieldText+QString(" lockkey");

	if (optFieldText.find(" comment", 0, false) < 0 || optFieldText.find("comment ", 0, false) < 0)
		optFieldText=optFieldText+QString(" comment");

    optFieldText = optFieldText.stripWhiteSpace();
    return const_cast<char*>(optFieldText.ascii());


}

void KbibNewEntryDefDlg::setContent(char *entryTypeName)
{
    BibEntryDef *entryType = getBibEntryDef(entryTypeName);
    refTypeEdit->setText(entryTypeName);
    refTypeEdit->setReadOnly(true);
    int nrq = entryType->nreq;

    for (int i = 0; i< nrq; i++)
    {
        reqFields->insertItem(entryType->getRequired(i), -1);
    }

    int nopt = entryType->nopt;
    char *fn;
    for (int i = 0; i< nopt; i++)
    {
        fn = entryType->getOptional(i);
        if (strcmp(fn, "lockkey"))
            optFields->insertItem(entryType->getOptional(i), -1);
    }



}


