/***************************************************************************
                          kbibselectentrytype  -  description
                             -------------------
    begin                : Fri Apr 9 2004
    copyright            : (C) 2004 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qlayout.h>
#include "kbibselectentrytype.h"

#include "bibentrytable.h"
#include "bibentry.h"
#include "entrydef.h"
#include <klocale.h>
extern vector<string> entrydefTab;
extern map<string, BibEntryDef *, less<string> > entrydefs;

KbibSelectEntryType::KbibSelectEntryType(QWidget *parent, const char *name, bool showSpecial, bool showHidden)
    :KDialogBase( parent, name , false, 0, KDialogBase::Ok|KDialogBase::Cancel, KDialogBase::Ok, false )
{

  QWidget* page = new QWidget(this);
  setMainWidget(page);
  QVBoxLayout* l = new QVBoxLayout(page, 0, KDialog::spacingHint());
  l->setSpacing(4);

  elabel = new QLabel("Reference type:", page);
  l->addWidget(elabel);

  entryList = new KComboBox(false, page);
  for (unsigned int i = 0; i<entrydefTab.size(); i++)
  {
	  char* st = const_cast<char*>(entrydefTab[i].c_str());
	  BibEntryDef *def = getBibEntryDef(st);
		
	  if ((!def->isHidden || showHidden) && (!def->isSpecial || showSpecial) )
		  entryList->insertItem (st, -1 ); 
  }
  entryList->setMinimumWidth(150);
  l->addWidget(entryList);
  l->addSpacing(10);
  l->addStretch(1);
}



KbibSelectEntryType::~KbibSelectEntryType()
{
  delete elabel;
  delete entryList;
}

char * KbibSelectEntryType::get_entryType(void)
{
  return const_cast<char*>((entryList->currentText()).ascii());
}


//#include "kbibselectentrytype.moc"
