/***************************************************************************
                          kbibstart  -  description
                             -------------------
    begin                : Sun Feb 29 2004
    copyright            : (C) 2004 by Thach Nguyen
    email                : thach@dragon.thach.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kbibstart.h"
#include "kbib.h"
#include <kiconloader.h>
#include <kfiledialog.h>
#include <klocale.h>

KBibStart::KBibStart(QWidget *parent, const char *name)
        :KDialogBase(parent, name, false, i18n("Kbib"), KDialogBase::Ok, KDialogBase::Ok,false, i18n("Kbib"))
{

    QWidget* page = new QWidget(this);
    setMainWidget(page);
    QVBoxLayout* l = new QVBoxLayout(page, 0, KDialog::spacingHint());

    QHBox* box1 = new QHBox(page);
    box1->setMargin(4);
    box1->setSpacing(4);

    image=KGlobal::instance()->iconLoader()->loadIcon( "kbib", KIcon::NoGroup, KIcon::SizeMedium);
    kbibImg = new QLabel(box1);
    kbibImg->setPixmap(image);
    kbibImg->setMinimumWidth(50);

    label = new QLabel("Welcome to KBib", box1);
    l->addWidget(box1);
    box1->setStretchFactor(kbibImg, 0);
    box1->setStretchFactor(label, 1);


    groupBox = new QVGroupBox("Please select action", page);
    l->addWidget(groupBox);

    buttonGroup = new QButtonGroup(page);
    newBibTex = new QRadioButton(i18n("Create new BibTex file"), groupBox);
    openBibTex = new QRadioButton(i18n("Open existing BibTex file:"), groupBox);

    QHBox* box2 = new QHBox(groupBox);
    box2->setMargin(0);
    box2->setSpacing(10);

    fileNameEntry = new QLineEdit(box2);
    browseBttn = new QPushButton("Browse", box2);

    QPixmap pix = KGlobal::iconLoader()->loadIcon(QString::fromLatin1("fileopen"), KIcon::Small);
    browseBttn->setPixmap(pix);
    browseBttn->setMinimumWidth(40);
    //browseBttn->setMinimumHeight(30);


    buttonGroup->hide();

    buttonGroup->insert(newBibTex);
    buttonGroup->insert(openBibTex);
    newBibTex->setChecked(0);
    openBibTex->setChecked(1);
    box1->setMaximumHeight(80);
    groupBox->setMinimumWidth(300);

    l->insertSpacing(2,20);

    connect(browseBttn, SIGNAL(clicked()), this, SLOT(slotBrowseFileName()) );

    setLastFileName();
}


KBibStart::~KBibStart()
{
    //delete newBibFileBttn;
    //delete openBibFileBttn;
    delete label;
    delete newBibTex;
    delete openBibTex;
    delete browseBttn;
    delete fileNameEntry;
    delete kbibImg;
    delete groupBox;
    delete buttonGroup;

}



int KBibStart::getAction()
{
    if (newBibTex->isChecked())
        return 1;
    //if (openBibTex->isChecked())
    else
		return 2;
}

QString KBibStart::getFileName()
{
    return fileNameEntry->text();
}

void KBibStart::slotBrowseFileName()
{
    QString filter = i18n("*.bib|BibTex files (*.bib)");
    filter += QString::fromLatin1("\n");
    filter += i18n("*|All files");


    KURL url = KFileDialog::getOpenURL(QString::fromLatin1(":open"), filter,
                                       this, i18n("Open File..."));


    if (!url.isEmpty())
    {
        fileNameEntry->setText(url.url());
        openBibTex->setChecked(1);
    }

}

//#include "kbibstart.moc"



/*!
    \fn KBibStart::setLastFileName()
 */
void KBibStart::setLastFileName()
{
    KBibApp *win=(KBibApp *) parent();
    QString lastFile = win->getLastFile();

    fileNameEntry->setText(lastFile);
}
